#!/usr/bin/perl
#######################################################
#-----------------------------------------------------#
#           BS Guestbook (version 3.0)                #
#-----------------------------------------------------#
# Copyright 1999 Brian Stanback  All Rights Reserved. #
#                                                     #
# Email: webmaster@stanback.net                       #
# Webpage: http://www.stanback.net                    #
#-----------------------------------------------------#
# You are free to change this script in any way you   #
# want, as long as the copyright and this message     #
# remain intact.  I will not be held responsable for  #
# any damage this script may cause. If you use this   #
# script I would  appreciate a link back to my site   #
# (stanback.net).  Enjoy! :-)                         #
#######################################################
#
# The following variables control how the guestbook works
#

$script_url = "bsguest.cgi";
 # The url of this script.

$data_file = "entries.txt";
 # File where guestbook entries are stored.

$show = 10;
 # Number of guestbook entries per page.

$my_email = 'webmaster@stanback.net';
 # Your email.

$tell_me = "yes";
 # Tell me when someone has signed the guestbook.

$thanks_response = "yes";
 # Send a thankyou email to the signer of the guestbook.

$sendmail = '/usr/lib/sendmail';
 # Where sendmail is located on your system.

$date_command = "/bin/date";
 # Date command on your system.

$block_slang = 1;
 # Block bad words (1=yes 2=no).

#
# The following variables control how the guestbook looks
#

$view_text_color = "#FFFFFF";
 # Color of the text on the entries page.

$view_link_color = "#00EEBB";
 # Color of the link on the entries page.

$view_bgcolor = "#003388";
 # Color of the background on the entries page.

$view_bgimage = "";
 # Background image on the entries page.

$view_hr_image = "wood4.jpg";
 # Horizontal rule image on the entries page.

$view_head_text = "This is what people have said...";
 # Text at the top of the entries page.

$add_text_color = "#000000";
 # Color of the text on the submit form.

$add_link_color = "#0000AA";
 # Color of the link on the submit form.

$add_bgcolor = "#C5C5C5";
 # Color of the background on the submit form.

$add_bgimage = "";
 # Background image on the submit form.

$add_head_text = "Brian's Guestbook";
 # Text on the top of the submit page.

###############################
# Don't change anything below #
###############################
$date = `$date_command +"%B %d, %Y"`; chop($date);
&get_form;

if ($FORM{'what'} =~ /\b(submit)\b/i){&submit}
elsif ($FORM{'what'} =~ /\b(view)\b/i){&view}
elsif ($FORM{'what'} =~ /\b(preview)\b/i){&preview}
else {&add}
exit(0);

###################################
# Write an entry to the guestbook #
###################################
sub submit
{
   @cookies = split(/; /, $ENV{'HTTP_COOKIE'});
   foreach $cook (@cookies)
   {
      ($name, $value) = split(/=/, $cook);
      $COOKIE{$name} = $value;
   }
   &error("Bad!", "Only one post per session!") if $COOKIE{'gbook'} == 1;

   # Check for name and comments
   &error("No name!", "Please fill in your name!") unless $FORM{'name'};
   &error("No comments!", "Please fill in your comments $FORM{'name'}") unless $FORM{'comments'};

   $FORM{'comments'} =~ s/\n/<br>/g;

   # Send the signer an e-mail
   if ($thanks_response =~ /yes/i && $FORM{'email'} =~ /\w+@\w+.\w+/)
   {
      open (MAIL, "|$sendmail -t") || die "Can't open $sendmail\n";
      print MAIL "To: $FORM{'email'}\n";
      print MAIL "Reply-to: $my_email\n";
      print MAIL "From: $my_email\n";
      print MAIL "Subject: Hello $FORM{'name'}\n\n";
      print MAIL "Thanks for signing my guestbook.  ";
      print MAIL "I hope you enjoyed your visit to my site and that you will come back again.\n\n";
      close (MAIL);
   }

   # Send administrator an e-mail
   if ($tell_me =~ /yes/i)
   {
      # Get the remote hostname.
      @subnet_numbers = split (/\./, $ENV{'REMOTE_ADDR'});
      $packed_address = pack ("C4", @subnet_numbers);
      $ENV{'REMOTE_HOST'} = gethostbyaddr($packed_address, 2);

      open (MAIL, "|$sendmail $my_email") || die "Can't open $sendmail!\n";
      print MAIL "Reply-to: $FORM{'email'}\n";
      print MAIL "From: $FORM{'email'} <$FORM{'name'}>\n";
      print MAIL "Subject: $FORM{'name'} signed the guestbook!\n\n";
      print MAIL "$FORM{'name'} <$FORM{'email'}> has made an entry to the guestbook.\n";
      print MAIL "with the IP $ENV{'REMOTE_ADDR'}\n";
      if ($ENV{'REMOTE_HOST'}){print MAIL "Using the hostname $ENV{'REMOTE_HOST'}\n"}
      print MAIL "on $date\n\n";
      print MAIL "User's Comments: $FORM{'comments'}\n";
      close (MAIL);
   }

   # Write a new entry to the guestbook file.
   open (FILE, ">>$data_file");
   flock(FILE, 2);
   seek(FILE, 0, 2);
   print FILE "$FORM{'name'}|$FORM{'email'}|";
   $FORM{'url'} =~ s#http://##eig;
   print FILE "http://$FORM{'url'}" if $FORM{'url'};
   print FILE "|$FORM{'city'}|$FORM{'state'}|$FORM{'country'}|$FORM{'comments'}|$date\n";
   close (FILE);
   flock(FILE, 8);

   # Set a Cookie
   print "Set-Cookie: gbook=1\n";
   # Redirect the user.
   print "Location: $script_url?what=view\n\n";
}

################################
# Print the guestbook add form #
################################
sub add
{
   print "Content-type: text/html\n\n";
   print "<html>\n";
   print "<head><title>Add to the Guestbook</title></head>\n";
   print "<body ";
   print "background=\"$add_bgimage\" " if $add_bgimage;
   print "link=\"$add_link_color\" alink=\"$add_link_color\" vlink=\"$add_link_color\" " if $add_link_color;
   print "bgcolor=\"$add_bgcolor\" " if $add_bgcolor;
   print "text=\"$add_text_color\" " if $add_text_color;
   print ">";
   print "<font face=\"Arial,Verdana\"><center>\n";
   print "<br><big><big>$add_head_text</big></big><br><br>\n";
   print "<hr><table cellspacing=\"3\" cellpadding=\"2\">\n";
   print "  <form method=\"post\" action=\"$script_url?what=preview\">\n";
   print "    <tr><td><b>Name:</b></td><td><input type=\"text\" name=\"name\" size=\"55\"></td></tr>\n";
   print "    <tr><td><b>E-Mail:</b></td><td><input type=\"text\" name=\"email\" size=\"55\"></td></tr>\n";
   print "    <tr><td><b>URL:</b></td><td><input type=\"text\" name=\"url\" value=\"http://\" size=\"55\"></td></tr>\n";
   print "    <tr><td><b>City:</b></td><td><input type=\"text\" name=\"city\" size=\"16\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>State: </b><input type=\"text\" name=\"state\" size=\"2\">&nbsp;&nbsp;&nbsp;&nbsp;<b>Country: </b><input type=\"text\" value=\"USA\" name=\"country\" size=\"10\"></td></tr>\n";
   print "    <tr><td valign=\"top\"><b>Comments:</b></td><td><textarea name=\"comments\" cols=\"48\" rows=\"8\"></textarea></td></tr>\n";
   print "    <tr><td colspan=\"2\">&nbsp;&nbsp;</td></tr>\n";
   print "    <tr><td></td><td><input type=\"submit\" value=\"Preview Entry\"></td></tr>\n";
   print "    <tr><td></td><td></form><form action=\"$script_url?what=view\" method=\"post\"><input type=\"submit\" value=\"View The Guestbook\"></form></td></tr>\n";
   print "</table><br><br>\n";
   print "</center></font>\n";
   print "</body></html>\n";
}

##########################
# Print out the preview  #
##########################
sub preview
{
   # Check for name and comments
   &error("No name!", "Please fill in your name!") unless $FORM{'name'};
   &error("No comments!", "Please fill in your comments $FORM{'name'}") unless $FORM{'comments'};

   print "Content-type: text/html\n\n";
   print "<html>\n";
   print "<head><title>Preview Entry</title></head>\n";
   print "<body";
   print " background=\"$view_bgimage\"" if $view_bgimage;
   print " link=\"$view_link_color\" alink=\"$view_link_color\" vlink=\"$view_link_color\"" if $view_link_color;
   print " bgcolor=\"$view_bgcolor\"" if $view_bgcolor;
   print " text=\"$view_text_color\"" if $view_text_color;
   print ">";
   print "<font face=\"Arial,Verdana\"><form action=\"$script_url?what=submit\" method=\"post\"><center><br>\n";
   print "<big><big>This is what your entry will look like...</big></big>\n";
   print "<p><img src=\"$view_hr_image\" width=\"100%\" height=\"4\"></p></center>\n\n";
   print "<table cellpadding=\"0\" cellspacing=\"1\" border=\"0\">\n";
   print "<tr><td>&nbsp;<b>Name:</b></td><td>$FORM{'name'} - $date</td></td>\n";
   print "<tr><td>&nbsp;<b>E-mail:</b></td><td><a href=\"mailto:$FORM{'email'}\">$FORM{'email'}</a></td></tr>\n" if $FORM{'email'};
   $FORM{'url_temp'} = $FORM{'url'}; $FORM{'url_temp'} =~ s#http://##eig;
   print "<tr><td>&nbsp;<b>My URL:</b></td><td><a href=\"$FORM{'$url'}\" target=\"link\">$FORM{'url'}</a></td></tr>\n" if $FORM{'url_temp'};
   print "<tr><td>&nbsp;<b>Location:</b></td><td>";
   if (!$FORM{'country'}){$FORM{'country'} = "USA"}
   if ($FORM{'city'} && $FORM{'state'}){print "$FORM{'city'}, $FORM{'state'} $FORM{'country'}"}
   elsif ($FORM{'city'}){print "$FORM{'city'}, $FORM{'country'}"}
   elsif ($state){print "$FORM{'state'}, $FORM{'country'}"}
   else {print "$FORM{'country'}"}
   print "</td></tr>\n";
   print "<tr><td valign=\"top\">&nbsp;<b>Comments: &nbsp;</b></td>\n";
   $FORM{'commentsp'} = $FORM{'comments'}; $FORM{'commentsp'} =~ s/\n/<br>/g;
   print "<td><b>$FORM{'commentsp'}</b></td></tr></table><p>\n";
   print "<center><img src=\"$view_hr_image\" width=\"100%\" height=\"4\"></center><br>\n\n";
   print "<input type=\"hidden\" name=\"name\" value=\"$FORM{'name'}\"><input type=\"hidden\" name=\"email\" value=\"$FORM{'email'}\"><input type=\"hidden\" name=\"url\" value=\"$FORM{'url'}\"><input type=\"hidden\" name=\"country\" value=\"$FORM{'country'}\"><input type=\"hidden\" name=\"city\" value=\"$FORM{'city'}\"><input type=\"hidden\" name=\"state\" value=\"$FORM{'state'}\"><input type=\"hidden\" name=\"comments\" value=\"$FORM{'comments'}\">\n";
   print "<input type=\"submit\" value=\"Submit Entry\"> <font size=\"2\">(please be patient)</font>\n";
   print "</center></form></font></body></html>\n";
}

####################
# View the entries #
####################
sub view
{
   $po = ($FORM{'o'}-$show);
   $no = ($FORM{'o'}+$show);

   open(FILE, $data_file);
   @entries = <FILE>;
   close(FILE);
   @entries = reverse @entries;

   # Print out the html
   print "Content-type: text/html\n\n";
   print "<html>\n";
   print "<head><title>Guestbook</title></head>\n";
   print "<body";
   print " background=\"$view_bgimage\"" if $view_bgimage;
   print " link=\"$view_link_color\" alink=\"$view_link_color\" vlink=\"$view_link_color\"" if $view_link_color;
   print " bgcolor=\"$view_bgcolor\"" if $view_bgcolor;
   print " text=\"$view_text_color\"" if $view_text_color;
   print ">";
   print "<font face=\"Arial,Verdana\"><center><br>\n";
   print "<big><big>$view_head_text</big></big>\n";
   print "<p><img src=\"$view_hr_image\" width=\"100%\" height=\"4\"></p></center>\n\n";
   foreach $line (@entries[$FORM{'o'}..$no-1])
   {
      chomp $line;
      if ($line)
      {
         ($name, $email, $url, $city, $state, $country, $comments, $date) = split(/\|/, $line);
         print "<table cellpadding=\"0\" cellspacing=\"1\" border=\"0\">\n";
         print "<tr><td>&nbsp;<b>Name:</b></td><td>$name - $date</td></td>\n";
         print "<tr><td>&nbsp;<b>E-mail:</b></td><td><a href=\"mailto:$email\">$email</a></td></tr>\n" if $email;
         print "<tr><td>&nbsp;<b>My URL:</b></td><td><a href=\"$url\" target=\"link\">$url</a></td></tr>\n"            if $url;
         print "<tr><td>&nbsp;<b>Location:</b></td><td>";
         if (!($country)){$country = "USA"}
         if ($city && $state){print "$city, $state $country"}
         elsif ($city){print "$city, $country"}
         elsif ($state){print "$state, $country"}
         else {print "$country"}
         print "</td></tr>\n";
         print "<tr><td valign=\"top\">&nbsp;<b>Comments: &nbsp;</b></td>\n";
         print "<td><b>$comments</b></td></tr></table><p>\n";
         print "<center><img src=\"$view_hr_image\" width=\"100%\" height=\"4\"></center><br>\n\n";
      }
   }
   print "<br><center>\n";
   if ($po >= 0){print "<a href=\"$script_url?what=view&o=$po\">[<< Prev]</a>"}
   $tno = $no; $tno++;
   if ($entries[$tno]){print " <a href=\"$script_url?what=view&o=$no\">[Next >>]</a>"}
   print "</center></body></html>\n";
}

######################
# Print out an error #
######################
sub error
{
      print "Content-type: text/html\n\n";
      print "<html>\n";
      print "<head><title>Error! - $_[0]</title></head>\n";
      print "<body ";
      print "background=\"$add_bgimage\" " if $add_bgimage;
      print "link=\"$add_link_color\" alink=\"$add_link_color\" vlink=\"$add_link_color\" " if $add_link_color;
      print "bgcolor=\"$add_bgcolor\" " if $add_bgcolor;
      print "text=\"$add_text_color\" " if $add_text_color;
      print ">";
      print "<font face=\"Arial,Verdana\"><center>\n";
      print "<br><br><h2>$_[1]</h2>\n";
      print "</center></font>\n";
      print "</body></html>\n";
      exit(0);
}

#####################
# Parse form input. #
#####################
sub get_form
{
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   @pairs2 = split(/&/, $ENV{'QUERY_STRING'});
   foreach $pair (@pairs, @pairs2)
   {
      ($name, $value) = split(/=/, $pair);
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

      # Strip SSI
      $value =~ s/<!--(.|\n)*-->/ /g;

      # Strip HTML
      $value =~ s/\|/ /g;
      $value =~ s/\;//g;
      $value =~ s/\&/ /g;
      $value =~ s/</&lt;/g;
      $value =~ s/>/&gt;/g;

      # Strip Bad Words
      $value =~ s/suck/stink/gi;
      $value =~ s/fuck/fudge/gi;
      $value =~ s/dick/richard/gi;
      $value =~ s/penis/jimmy/gi;
      $value =~ s/shit/shoot/gi;
      $value =~ s/fag/bad ass. I am a fag./gi;

      $FORM{$name} = $value;
   }
   $FORM{'email'} =~ s/^([^ ]+) (.*)/$1/g;
}
